﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using Microsoft.Practices.Composite.Presentation.Commands;
using System.Windows.Input;
using System.ComponentModel;

namespace WpfApplication7
{
    public class ScoreListViewModel : INotifyPropertyChanged
    {
        public ScoreListViewModel()
        {
            this.StudentList = new ObservableCollection<Student>(StudentService.RetrieveStudentList());

            this.PropertyChanged += ModelPropertyChanged;
        }

        void ModelPropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            switch (e.PropertyName)
            {
                case "IsPassed":
                    this.StudentList = new ObservableCollection<Student>(
                        this.IsPassed ? StudentService.RetrievePassedStudentList() : StudentService.RetrieveStudentList());

                    break;
                default:
                    break;
            }
        }

        public ScoreListView View { get; set; }

        private bool isPassed;
        public bool IsPassed
        {
            get
            {
                return this.isPassed;
            }
            set
            {
                if (this.isPassed != value)
                {
                    this.isPassed = value;
                    OnPropertyChanged("IsPassed");
                }
            }
        }

        private ObservableCollection<Student> studentList;
        public ObservableCollection<Student> StudentList
        {
            get
            {
                return this.studentList;
            }
            set
            {
                if (this.studentList != value)
                {
                    this.studentList = value;
                    OnPropertyChanged("StudentList");
                }
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion
    }
}
